=== debian/changelog ===
visp (3.0.0-4) unstable; urgency=medium

  * Remove libusb-1.0-0-dev explicit dependency that will come from
    libfreenect-dev implicit dep.
  * Remove libfreenect also for kfreebsd-amd64 and kfreebsd-i386
    (BD-Uninstallable)
  * Since Ogre removal, remove dh_override_install (Closes: #813564)
  * Remove doxygen-latex useless dependency

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Wed, 03 Feb 2016 11:56:55 +0100

visp (3.0.0-3) unstable; urgency=medium

  * Remove Ogre and Ois dependencies to prevent ViSP from autoremoval
    from testing on 2016-02-19 due to a transitively dependency on blender
    affected by RC bug(s) 804678 and 810065.

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 01 Feb 2016 18:00:21 +0100

visp (3.0.0-2) unstable; urgency=medium

  * Fix missing Breaks/Replaces relation to fix upgrade from
    testing (Closes: #810354)
  * Switch to libusb-1.0 (Closes: #810464)
  * Introduce patches to fix issues

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Sat, 09 Jan 2016 18:23:36 +0100

visp (3.0.0-1) unstable; urgency=medium

  * Update watch file since website migration
  * Imported Upstream version 3.0.0
  * Update debian material for ViSP 3.0.0

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Thu, 31 Dec 2015 18:53:34 +0100

visp (2.10.0+dfsg-2) unstable; urgency=medium

  * Make testing arch dependent (Closes: #806876)
  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev
    (Closes: #807228)

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 07 Dec 2015 21:54:33 +0100

visp (2.10.0+dfsg-1) unstable; urgency=medium

  * Replace lena non dfsg images by monkey images (Closes: #794861)
  * Bashism in /bin/sh script already fixed since 2.10.0-1 (Closes: #772331)

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Fri, 18 Sep 2015 10:43:50 +0200
